package me.Demon.DemonCropBuyShop;

import com.sun.scenario.effect.Crop;
import me.Demon.DemonCropBuyShop.listener.BuyGui;
import me.Demon.DemonCropBuyShop.listener.GuiListener;
import me.Demon.DemonCropBuyShop.listener.MarkStats;
import me.Demon.DemonCropBuyShop.listener.PlayerCropBuy;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Random;

public class Main extends JavaPlugin {
    public static Main plugin;
    public static int TodayBank = 0;
    public static String prefix = "§7[§6战争领域§7] §f";
    public static LinkedHashMap<String, CropData> dataAPI = new LinkedHashMap<>();

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        Bukkit.getServer().getPluginManager().registerEvents(new PlayerCropBuy(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new GuiListener(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new MarkStats(), plugin);
        Bukkit.getConsoleSender().sendMessage("§e[农贸商店] §r正在启动插件...");
        for (String cropType : getConfig().getKeys(false)){
            if(getConfig().getString(cropType+".log") != null){
                dataAPI.put(cropType,new CropData(cropType));
            }
        }
        Bukkit.getConsoleSender().sendMessage("§e[农贸商店] §r载入农贸: "+dataAPI.size()+"个");
        long time = 20L * 60 * 30;
        new TimeCheckRunnable().runTaskTimer(this, time, time);
        if (Bukkit.getPluginManager().getPlugin("PlaceholderAPI") != null) {
            new Placeholders(this).register();
        }
    }

    @Override
    public void onDisable() {
        for (String cropType : dataAPI.keySet()){
            Main.dataAPI.get(cropType).SaveData();
        }
        Bukkit.getConsoleSender().sendMessage("§e[农贸商店] §r正在关闭插件...");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("cropshop")) {
            if(args.length == 1 && args[0].equalsIgnoreCase("open")){
                new BuyGui((Player) sender);
            }

            if(args.length == 1 && args[0].equalsIgnoreCase("start") && sender.isOp()){
                for (String corpType : Main.dataAPI.keySet()) {
                    CropShopAPI.Start_Updata_Event(corpType,0);
                }
                sender.sendMessage("[日志-农贸商店] 倒计时结束随机市场调整.");
            }

            if(args.length == 1 && args[0].equalsIgnoreCase("resetprice") && sender.isOp()){
                for (String corpType : Main.dataAPI.keySet()) {
                    CropShopAPI.Start_Updata_Event(corpType,0);
                }
                sender.sendMessage("[日志-农贸商店] 倒计时结束随机市场调整.");
            }

        }
        return false;
    }
    public static boolean itemIsNull(ItemStack item){return item == null || item.getType() == Material.AIR;}
    public static boolean itemIsLore(ItemStack item){return item.getItemMeta().getLore() == null;}
    public static int getRandomInt(int max,int min){return new Random().nextInt(max) + min;}
}

