package me.Demon.DemonCropBuyShop.listener;

import me.Demon.DemonCropBuyShop.CropData;
import me.Demon.DemonCropBuyShop.Main;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class BuyGui implements InventoryHolder {

    private Inventory inventory;

    private Player player;

    public BuyGui(Player p){
        this.player = p;
        inventory = Bukkit.createInventory(this,36,"战争领域 - 农贸市场");
        int slot = 9;
        for (String itemType : Main.dataAPI.keySet()){
            CropData dataAPI = Main.dataAPI.get(itemType);
            Material material = Material.valueOf(itemType);
            ItemStack item = new ItemStack(material,1);
            inventory.setItem(slot,shopitem(item,dataAPI));
            slot++;
        }
        for (int i = 27;i<inventory.getSize();i++) {
            inventory.setItem(i, glass("§7[[§a▧▧§7]]", 7));
        }
        inventory.setItem(30, glass("§7[[§a▧▧§7]]", 15));
        inventory.setItem(31, BackBook("§a返回菜单"));
        inventory.setItem(32, glass("§7[[§a▧▧§7]]", 15));
        player.openInventory(inventory);
    }

    public static ItemStack shopitem(ItemStack items,CropData dataAPI){
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7物品: §r"+ DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7单位: §2组");
        // 计算现价和上一次变动价格的涨幅和跌幅
        double change = dataAPI.getCurrenAndPrevious();
        String show = new DecimalFormat("###.##").format(change);

        String m = new DecimalFormat("###.##").format(dataAPI.getMoney());
        if(change >= 0) {
            lore.add("§d§l★§7现价: §6" + m+"元 §a(+"+show+"%)");
        }else{
            lore.add("§d§l★§7现价: §6" + m+"元 §c("+show+"%)");
        }
        lore.add("§b§l★§7历史行情:");
        lore.addAll(dataAPI.getLog());
        lore.add("§8#祝老板成为农贸大亨!");
        lore.add(" ");
        if (item.getType() == Material.EGG) {
            lore.add("§a§l★§7左键点击 §f| §7出售16个");
            lore.add("§a§l★§7右键点击 §f| §7出售27组");
        }else{
            lore.add("§a§l★§7左键点击 §f| §7出售64个");
            lore.add("§a§l★§7右键点击 §f| §7出售27组");
        }
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack glass(String name,int date){
        ItemStack item = new ItemStack(160,1,(short) date);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }
    public static ItemStack BackBook(String name){
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    @Override
    public Inventory getInventory() {
        return null;
    }
}
