package me.Demon.DemonCropBuyShop.listener;

import me.Demon.DemonCropBuyShop.CropData;
import me.Demon.DemonCropBuyShop.Event.MarktStatsEvent;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

import java.text.DecimalFormat;

public class MarkStats implements Listener {

    @EventHandler
    public void markStats(MarktStatsEvent e){
        CropData dataAPI = e.getDataAPI();
        // 刷新现在价格
        double current_price = dataAPI.getMoney();
        // 判断本次事件是涨还是跌
        int mk_stats = e.getType();
        boolean butt = false;
        if(mk_stats == 1){
            if(!isMoneyUpLimit(dataAPI.getDmoney(),current_price)){
                butt = true;
            }
        } else {
            if(!isMoneyDownLimit(dataAPI.getDmoney(),current_price)){
                butt = true;
            }
        }
        if(butt){
            // 首先记录当前价格
            double change = dataAPI.getCurrenAndPrevious();
            String show = new DecimalFormat("###.##").format(change);
            if (change >= 0) {
                String str_lore = " §f- §6" + dataAPI.getMoney() + " §a§l↑↑ §a" + show + "%";
                dataAPI.setCropMarketLog(str_lore);
            } else {
                String str_lore = " §f- §6" + dataAPI.getMoney() + " §c§l↓↓ §c" + show + "%";
                dataAPI.setCropMarketLog(str_lore);
            }
            // 设置上次价格
            dataAPI.setLast(current_price);
            // 设置当前价格
            dataAPI.setMoney(e.getMoney());
        }
    }


    public static boolean isMoneyUpLimit(double Dmoney,double price){
        // Dmoney = 10000   * 1.3  =  13000;
        // Bukkit.getConsoleSender().sendMessage("price = "+price+"  default = "+Dmoney);
        if(price >= (Dmoney * 1.5)){
            return true;
        }
        return false;
    }
    public static boolean isMoneyDownLimit(double Dmoney,double price){
        // Dmoney = 10000   * 1.3  =  13000;
        // Bukkit.getConsoleSender().sendMessage("price = "+price+"  default = "+Dmoney);
        if(price <= (Dmoney * 0.3)){
            return true;
        }
        return false;
    }
}
