package me.Demon.DemonCropBuyShop;

import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.inventory.ItemStack;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class CropData {

    private String cropType;

    private double dmoney;
    private double money;

    private double last;

    private List<String> log;

    public CropData(String cropType) {
        this.cropType = cropType;
        FileConfiguration yml = Main.plugin.getConfig();
        this.dmoney = yml.getDouble(cropType + ".default");
        this.money = yml.getDouble(cropType + ".money");
        this.last = yml.getDouble(cropType + ".last");
        this.log = yml.getStringList(cropType + ".log");
    }

    public void SaveData() {
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set(cropType + ".default", this.dmoney);
        yml.set(cropType + ".money", this.money);
        yml.set(cropType + ".last", this.last);
        yml.set(cropType + ".log", this.log);
        Main.plugin.saveConfig();
    }

    public String getCropType() {
        return cropType;
    }

    public ItemStack getItem() {
        return new ItemStack(Material.valueOf(this.getCropType()));
    }

    public double getDmoney() {
        return dmoney;
    }

    public double getMoney() {
        return money;
    }

    public void setMoney(double money) {
        this.money = money;
    }

    public double getLast() {
        return last;
    }

    public void setLast(double last) {
        this.last = last;
    }

    public List<String> getLog() {
        return log;
    }

    public void setLog(List<String> log) {
        this.log = log;
    }

    public void setCropMarketLog(String lore) {
        List<String> list = new ArrayList<>();
        list.add(lore);
        List<String> jiu_log = getLog();
        if (jiu_log.size() >= 4) {
            for (int i = 0; i < 4; i++) {
                list.add(jiu_log.get(i));
            }
        } else {
            list.addAll(getLog());
        }
        setLog(list);
    }

    public String getCurrenBFB() {
        double change = getCurrenAndPrevious();
        if (change >= 0) {
            return "§a§l↑↑ §a" + new DecimalFormat("###.##").format(change) + "%";
        } else {
            return "§c§l↓↓ §c" + new DecimalFormat("###.##").format(change) + "%";
        }
    }

    public double getCurrenAndPrevious() {
        double change = getMoney() - getLast();
        return (change / getLast()) * 100;
    }
}
