package me.Demon.DemonCropBuyShop;

import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

public class Placeholders extends PlaceholderExpansion {

    private Plugin plugin;
    public Placeholders(Plugin plugin) {
        this.plugin = plugin;
    }
    @Override
    public boolean persist() {
        return true;
    }

    @Override
    public boolean canRegister() {
        return true;
    }

    @Override
    public String getAuthor() {
        return plugin.getDescription().getAuthors().toString();
    }

    @Override
    public String getIdentifier() {
        return "dcropshop";
    }


    // %dcropshop_bfb_ndsad%
    // %dcropshop_jg_ndsad%
    @Override
    public String getVersion() {
        return plugin.getDescription().getVersion();
    }

    public String onPlaceholderRequest(Player p, String indentifier) {if (p == null) { return ""; }
        String[] sp = indentifier.split("_");
        if (sp.length == 2) {
            CropData dataAPI = Main.dataAPI.get(sp[1]);
            if (sp[0].equalsIgnoreCase("jg")) {
                return "" + dataAPI.getMoney();
            } else {
                return "" + dataAPI.getCurrenBFB();
            }
        }else if (sp.length == 3) {
            String cropType = sp[1]+"_"+sp[2];
            CropData dataAPI = Main.dataAPI.get(cropType);
            if (sp[0].equalsIgnoreCase("jg")) {
                return "" + dataAPI.getMoney();
            } else {
                return "" + dataAPI.getCurrenBFB();
            }
        }
        return "-999";
    }
}
